from typing import (
    Generic,
    List,
)

from pandas import Series
from pandas.core.base import NoNewAttributesMixin as NoNewAttributesMixin

from pandas._typing import T

def cat_core(list_of_columns: List, sep: str): ...
def cat_safe(list_of_columns: List, sep: str): ...
def str_count(arr, pat, flags: int = ...): ...
def str_contains(
    arr, pat, case: bool = ..., flags: int = ..., na=..., regex: bool = ...
): ...
def str_startswith(arr, pat, na=...): ...
def str_endswith(arr, pat, na=...): ...
def str_replace(
    arr, pat, repl, n: int = ..., case=..., flags: int = ..., regex: bool = ...
): ...
def str_repeat(arr, repeats): ...
def str_match(arr, pat, case: bool = ..., flags: int = ..., na=...): ...
def str_extract(arr, pat, flags: int = ..., expand: bool = ...): ...
def str_extractall(arr, pat, flags: int = ...): ...
def str_get_dummies(arr, sep: str = ...): ...
def str_join(arr, sep): ...
def str_findall(arr, pat, flags: int = ...): ...
def str_find(arr, sub, start: int = ..., end=..., side: str = ...): ...
def str_index(arr, sub, start: int = ..., end=..., side: str = ...): ...
def str_pad(arr, width, side: str = ..., fillchar: str = ...): ...
def str_split(arr, pat=..., n=...): ...
def str_rsplit(arr, pat=..., n=...): ...
def str_slice(arr, start=..., stop=..., step=...): ...
def str_slice_replace(arr, start=..., stop=..., repl=...): ...
def str_strip(arr, to_strip=..., side: str = ...): ...
def str_wrap(arr, width, **kwargs): ...
def str_translate(arr, table): ...
def str_get(arr, i): ...
def str_decode(arr, encoding, errors: str = ...): ...
def str_encode(arr, encoding, errors: str = ...): ...
def forbid_nonstring_types(forbidden, name=...): ...
def copy(source): ...

class StringMethods(NoNewAttributesMixin, Generic[T]):
    def __init__(self, data) -> None: ...
    def __getitem__(self, key) -> T: ...
    def __iter__(self): ...
    def cat(self, others=..., sep=..., na_rep=..., join: str = ...) -> T: ...
    def split(self, pat=..., n: int = ..., expand: bool = ...) -> T: ...
    def rsplit(self, pat=..., n: int = ..., expand: bool = ...) -> T: ...
    def partition(self, sep: str = ..., expand: bool = ...) -> T: ...
    def rpartition(self, sep: str = ..., expand: bool = ...) -> T: ...
    def get(self, i) -> T: ...
    def join(self, sep) -> T: ...
    def contains(
        self, pat, case: bool = ..., flags: int = ..., na=..., regex: bool = ...
    ) -> Series[bool]: ...
    def match(self, pat, case: bool = ..., flags: int = ..., na=...) -> T: ...
    def replace(
        self, pat, repl, n: int = ..., case=..., flags: int = ..., regex: bool = ...
    ) -> T: ...
    def repeat(self, repeats) -> T: ...
    def pad(self, width, side: str = ..., fillchar: str = ...) -> T: ...
    def center(self, width, fillchar: str = ...) -> T: ...
    def ljust(self, width, fillchar: str = ...) -> T: ...
    def rjust(self, width, fillchar: str = ...) -> T: ...
    def zfill(self, width) -> T: ...
    def slice(self, start=..., stop=..., step=...) -> T: ...
    def slice_replace(self, start=..., stop=..., repl=...) -> T: ...
    def decode(self, encoding, errors: str = ...) -> T: ...
    def encode(self, encoding, errors: str = ...) -> T: ...
    def strip(self, to_strip=...) -> T: ...
    def lstrip(self, to_strip=...) -> T: ...
    def rstrip(self, to_strip=...) -> T: ...
    def wrap(self, width, **kwargs) -> T: ...
    def get_dummies(self, sep: str = ...) -> T: ...
    def translate(self, table) -> T: ...
    count = ...
    startswith = ...
    endswith = ...
    findall = ...
    def extract(self, pat, flags: int = ..., expand: bool = ...) -> T: ...
    def extractall(self, pat, flags: int = ...) -> T: ...
    def find(self, sub, start: int = ..., end=...) -> T: ...
    def rfind(self, sub, start: int = ..., end=...) -> T: ...
    def normalize(self, form) -> T: ...
    def index(self, sub, start: int = ..., end=...) -> T: ...
    def rindex(self, sub, start: int = ..., end=...) -> T: ...
    len = ...
    lower = ...
    upper = ...
    title = ...
    capitalize = ...
    swapcase = ...
    casefold = ...
    isalnum = ...
    isalpha = ...
    isdigit = ...
    isspace = ...
    islower = ...
    isupper = ...
    istitle = ...
    isnumeric = ...
    isdecimal = ...
